#ifndef MAX_SIZE_BUF
#define MAX_SIZE_BUF 99
#endif


#ifndef cdecl
#define cdecl __CDECL
#endif

typedef struct my_aes_win_values
{
        unsigned short kind;	/* gadgets */
	unsigned short hslide; /* position slider horizontale 1 a 1000 */
	unsigned short vslide;	/* position slider vertical 1 a 1000 */
	unsigned short hslsize; /* taille slider horizontale 1 a 1000 */
	unsigned short vslsize;	/* taille slider vertical 1 a 1000 */
} my_aes_WIN_VALUES;

typedef struct my_aes_win_strings
{
        char name[MAX_SIZE_BUF+1]; /* Texte titre fenetre */
	char info[MAX_SIZE_BUF+1]; /* texte info fenetre */
} my_aes_WIN_STRINGS;

typedef struct  around
{
	long top_height; /* hauteur au dessus de la fenetre */
	long left_width; /* largeur  gauche de la fenetre */
	long right_width;	/* largeur  droite de la fenetre */
	long low_height;	/* hauteur en bas de la fenetre */
} AROUND;


/* dclarations pour le LDG JPEG.LDG de zorro */

typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned long uint32;
typedef char int8;
typedef short int16;
typedef long int32;

typedef struct
{
	uint8	red;
	uint8	green;
	uint8	blue;
} COLOR_MAP;


typedef struct _img_info *IMGINFO;

typedef struct _img_info
{
	/* Data returned by the decoder Picture's initialisation */
	uint16    	width;					/* Picture width 											*/
	uint16		height;					/* Picture Height											*/
	uint16 		components;  			/* Picture components 										*/
	uint16	 	planes;					/* Picture bits by pixel									*/
	uint32     	colors;					/* Picture colors number									*/
	int16		orientation;			/* picture orientation: UP_TO_DOWN or DONW_TO_UP ( ex: TGA)	*/
	uint16		page;					/* Number of page/image in the file 						*/
	uint16		delay;					/* Animation delay in 200th sec. between each frame.		*/
	uint16		num_comments;			/* Lines in the file's comment. ( 0 if none) 	 			*/
	uint16		max_comments_length;	/* The length of the greater line in the comment 			*/
	int16		indexed_color;			/* Picture has a palette: 0) No 1) Yes						*/
	int16		memory_alloc;			/* where to do the memory allocation for the reader_read 
										   function buffer, possible values are ST_RAM or TT_RAM	*/
	COLOR_MAP	palette[256];			/* Palette in standard RGB format							*/


	/* data send to the codec */
	uint32		background_color;		/* The wanted background's color in hexa */		
	int16		thumbnail;				/* 1 if true else 0.
										   Some format have thumbnail inside the picture, if 1, we 
										   want only this thumbnail and not the image itself 		*/
	uint16		page_wanted;			/* The wanted page to get for the reader_read() function 											   
										   The first page is 0 and the last is img_info->page - 1	*/											   


	/* The following variable are only for Information Prupose, the zview doesn't 
	   use it for decoding routine but only for the information dialog								*/
	int8		info[40];				/* Picture's info, for ex: "Gif 87a" 						*/
	int8		compression[5];			/* Compression type, ex: "LZW" 								*/
	uint16    	real_width;				/* Real picture width( if the thumbnail variable is 1)		*/
	uint16		real_height;			/* Ral picture Height( if the thumbnail variable is 1)		*/


	/* Private data for the plugin */
	void		*_priv_ptr;			
	void		*_priv_ptr_more;			
	void		*__priv_ptr_more;

	int32		_priv_var;
	int32		_priv_var_more;

} img_info;





typedef struct {    /* see documentation after */

  void cdecl (*transforme24b_2_screen)(void *source, void *dest, long width, long height); 
  void *cdecl (*Malloc)(unsigned long size);
  void cdecl (*Free)(void *mem);
  long graf_handle_vdi; /* VDI handle retuurn by graf_handle() */
  long cdecl (*extern_wind_get)(long handle, long mode, INT16 *parm1, INT16 *parm2, INT16 *parm3, INT16 *parm4, void *client);
  char **myaes_folder; /* MyAES path folder */
  long cdecl (*reader_init_jpg)(const char *name,IMGINFO info);
  long cdecl (*reader_read_jpg)(IMGINFO info,unsigned char *buffer);
  void cdecl (*reader_quit_jpg)(IMGINFO info);
  char **skins_folder;  /* windframe path folder */
  void cdecl (*myaes_G_TITLE_COLOR)(long color); /* put VDI colr of G_TITLE */
  GRECT * cdecl (*get_win_rect)(void *pt_win);
  void cdecl (*memcpy)( void *dest, const void *source, unsigned long n );
  my_aes_WIN_VALUES * cdecl (*get_win_values)(void *pt_win);
  my_aes_WIN_STRINGS * cdecl (*get_win_strings)(void *pt_win);
  long cdecl (*get_win_id)(void *pt_win);
  void * cdecl (*get_client)(void *pt_win);

} WIDGETS_UTILS;



/* documentation 

void cdecl (*transforme24b_2_screen)(void *source, void *dest, long width, long height) :

    Transform 24 bytes RGB picture in a picture at the screen resolution.
    This function can be directly call

                  ---------------

void *cdecl (*Malloc)(unsigned long size)
    Do memory allocation for you, this memory can be share between application
    This allocation should be perform only at start of the windframe
    This function should not be used directly, it should be call by ldg_callback() function

                  ---------------

void cdecl (*Free)(void *mem)
    Free memory alloc by previous function
    This function should only used when the windframe is closed
    This function should not be used directly, it should be call by ldg_callback() function

                  ---------------

long cdecl (*extern_wind_get)(long handle, long mode, INT16 *parm1, INT16 *parm2, INT16 *parm3, INT16 *parm4, void *client)
    You can call wind_get() directly with this function
    This function should not be used directly, it should be call by ldg_callback() function

                  ---------------

long cdecl (*reader_init_jpg)(const char *name,IMGINFO info)
    Open a jpeg file (see jpeg.ldg documentation from Zorro)
    This function should be perform only at start of the windframe
    This function can be directly call

                  ---------------

long cdecl (*reader_read_jpg)(IMGINFO info,unsigned char *buffer)
    Read a jpeg file already open by reader_init_jpg() (see jpeg.ldg documentation from Zorro)
    This function should be perform only at start of the windframe
    This function can be directly call

                  ---------------

void cdecl (*reader_quit_jpg)(IMGINFO info)
    Close a jpeg file already open by reader_init_jpg() (see jpeg.ldg documentation from Zorro)
    This function should be perform only at start of the windframe
    This function can be directly call

                  ---------------

void cdecl (*myaes_G_TITLE_COLOR)(long color)
    function to put color VDI for G_TITLE
    This function should not be used directly, it should be call by ldg_callback() function

                  ---------------

GRECT * __CDECL (*get_win_rect)(void *pt_win)
    This function return windows coordinates
    This function should not be used directly, it should be call by ldg_callback() function

                  ---------------

void cdecl (*memcpy)( void *dest, const void *source, unsigned long n )
    internal memcpy()
    This function should not be used directly, it should be call by ldg_callback() function

                  ---------------

my_aes_WIN_VALUES * cdecl (*get_win_values)(void *pt_win)
    This function return important value for windframe, see my_aes_WIN_VALUES structure
    This function should not be used directly, it should be call by ldg_callback() function

                  ---------------

my_aes_WIN_STRINGS * cdecl (*get_win_strings)(void *pt_win)
    This function return the name and the info string of the window, see my_aes_WIN_STRINGS structure
    This function should not be used directly, it should be call by ldg_callback() function

                  ---------------

long cdecl (*get_win_id)(void *pt_win)
    Return the id of the windows
    This function should not be used directly, it should be call by ldg_callback() function

                  ---------------

void * cdecl (*get_client)(void *pt_win)
    Return pointer to the window client need by extern_wind_get()
    This function should not be used directly, it should be call by ldg_callback() function

*/